/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/

package de.eoda.qtafi.surveymanager.auth;

import java.util.Set;

public class Account {
	
	public static final String ADMINSTRATOR_ROLE = "admin";

	public final String name;
	public final int id;
	private boolean administrator = false;
	
	private Set<String> accessibleProjects = null;
	
	public Account(int id, String name) {
		this.id = id;
		this.name = name;
	}
	
	public void addAccessibleProject(String name){
		this.accessibleProjects.add(name);
	}
	
	public void removeAccessibleProject(String name){
		this.accessibleProjects.remove(name);
	}
	
	public void setAccessibleProjects(Set<String> accessibleProjects) {
		this.accessibleProjects = accessibleProjects;
	}
	
	public Set<String> getAccessibleProjects() {
		return accessibleProjects;
	}
	
	public boolean isProjectAccessable(String name){
		return this.accessibleProjects.contains(name);
	}
	
	
	public void setAdministrator(boolean administrator) {
		this.administrator = administrator;
	}
	
	public boolean isAdministrator() {
		return administrator;
	}
	
	@Override
	public String toString() {
		return this.name;
	}
}
