/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.auth;

import java.io.Serializable;

import org.apache.shiro.session.Session;
import org.apache.shiro.session.UnknownSessionException;
import org.apache.shiro.session.mgt.DefaultSessionContext;
import org.apache.shiro.session.mgt.SessionKey;
import org.apache.shiro.web.session.mgt.DefaultWebSessionManager;

public class SessionManager extends DefaultWebSessionManager {
	
	
	
	@Override
	protected Session retrieveSession(SessionKey sessionkey)
			throws UnknownSessionException {
		
		try{
			Session session =  super.retrieveSession(sessionkey);
			return session;
		}
		catch(UnknownSessionException ex){ 
			System.err.println(ex.getMessage());
		}
		
		if(sessionkey.getSessionId() == null){
			return null;
		}
		//System.out.println(sessionkey.getSessionId());
		DefaultSessionContext sc = new DefaultSessionContext();
		sc.setSessionId(sessionkey.getSessionId());
		return createSession(sc);
	}
	
	

	@Override
	protected Session retrieveSessionFromDataSource(Serializable sessionId)
			throws UnknownSessionException {
		
		try{
			Session session =  super.retrieveSessionFromDataSource(sessionId);
			
			return session;
		}
		catch(UnknownSessionException ex){ 
			//ex.printStackTrace();
			System.err.println(ex.getMessage());
		}
		//System.out.println(sessionId);
		
		//DefaultSessionContext sc = new DefaultSessionContext();
		//sc.setSessionId(sessionId);
		//return createSession(sc);
		return null;
	}

}
