/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.dnd;

import java.io.UnsupportedEncodingException;

import org.eclipse.rap.rwt.SingletonUtil;
import org.eclipse.swt.dnd.ByteArrayTransfer;
import org.eclipse.swt.dnd.TransferData;

public class CustomTextTransfer extends ByteArrayTransfer {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private static final String TYPE_NAME = "text";
	private static final int TYPE_ID = registerType(TYPE_NAME);

	private CustomTextTransfer() {
	}

	public static CustomTextTransfer getInstance() {
		return SingletonUtil.getSessionInstance(CustomTextTransfer.class);
	}

	public void javaToNative(Object object, TransferData transferData) {
		if (!checkText(object) || !isSupportedType(transferData)) {
			// DND.error( DND.ERROR_INVALID_DATA );
			return;
		}
		transferData.data = object;
		transferData.result = 1;
	}

	public Object nativeToJava(TransferData transferData) {
		if (!isSupportedType(transferData) || transferData.data == null) {
			return null;
		}
		if (transferData.result != 1)
			return null;
		return transferData.data;
	}

	protected int[] getTypeIds() {
		return new int[] { TYPE_ID };
	}

	protected String[] getTypeNames() {
		return new String[] { TYPE_NAME };
	}

	boolean checkText(Object object) {
		return (object != null && object instanceof String && ((String) object).length() > 0);
	}

	protected boolean validate(Object object) {
		return checkText(object);
	}

	static byte[] stringToBytes(String string) {
		byte[] bytes = null;
		try {
			bytes = string.getBytes("UTF-8");
		} catch (UnsupportedEncodingException ignore) {
		}
		return bytes;
	}

}
