/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/

/**
 * 
 * 
 */
(function(){
	'use strict';
	
	rap.registerTypeHandler("Editorhtmlcomposite", {
	    factory : function(properties) {
	    	return new Editorhtmlcomposite(properties);
	    },
	    
	    destructor: "destroy",
	    properties: ["html", "scrollTo"],
	    events: ["dblclick", "singleclick"]
	});
	
	var Editorhtmlcomposite = function(properties) {
		bindAll(this, ["layout", "onReady", "onSend", "onRender", "setHtml", "setScrollTo"]);
		this.id = "",
		this.parent = rap.getObject(properties.parent);
		this.element = document.createElement("div");
		this.element.setAttribute('class', 'html-composite');
		this.element.setAttribute('style', 'height: 100%')
		this.parent.append(this.element); 
		//this.parent.addListener("Resize", this.layout);
		rap.on("render", this.onRender);
	};
	
	Editorhtmlcomposite.prototype = {
	    ready: false,
	    html: '<h1>---</h1>',
	    container: null,
	    
	    onRender: function(){
	    	//console.log('onrender ' + this.element);
	    	console.log(this);
	    	console.log(this._rwtId);
	    	var _this = this;
	    	if(this.element){
	    		rap.off("render", this.onRender);
	    		this.element.innerHTML = "<div id='html-container-"+this._rwtId+"' style='overflow-y:auto; width:100%; height:100%;'>"+ this.html + "</div>";
	    		
	    		$('.question1').dblclick(function(){
	    			rap.getRemoteObject(_this).notify("dblclick", { uid: $(this).attr('uid') });
	    			console.log("edit " + $(this).attr('uid'));
	    		});
	    		$('.question1').click(function(){
	    			rap.getRemoteObject(_this).notify("singleclick", { uid: $(this).attr('uid') });
	    		});
	    		rap.on("send", this.onSend);
	    	}
	    },
	
	    onSend: function() {
	    	//rap.getRemoteObject(this).set("html", this.html);
	    },
	    
	    setHtml: function(_html){
	    	this.html = _html;
	    	var _this = this;
	    	$('#html-container-'+this._rwtId).html(this.html);
	    	$('.question1').dblclick(function(){
    			rap.getRemoteObject(_this).notify("dblclick", { uid: $(this).attr('uid') });
    		});
	    	$('.question1').click(function(){
    			rap.getRemoteObject(_this).notify("singleclick", { uid: $(this).attr('uid') });
    		});
	    },
	    
	    setScrollTo: function(_id){
	    	if($('#' + _id).length){
	    		this.scrollToElement('#' + _id);
	    	}
	    },
	    
	    
	    scrollToElement: function(selector, time) {
	        var time = typeof(time) != 'undefined' ? time : 500;
	        var element = $(selector);
	        var container = $('#html-container-' + this._rwtId);
	        $('#html-container-' + this._rwtId).animate({
	        	 scrollTop:  container.scrollTop() - container.offset().top + element.offset().top 
	        }, time);           
	    },

	    
		destroy: function() {
			rap.off("send", this.onSend);
		    this.element.parentNode.removeChild(this.element);
		},

		layout: function() {
			if(this.ready) {
				var area = this.parent.getClientArea();
		        this.element.style.left = area[0] + "px";
		        this.element.style.top = area[1] + "px";
		    }
		},
	
		onReady: function(){
			console.log('onReady');
			this.ready = true;
			this.layout();
		}
	};
	
	var bind = function(context, method) {
		return function(){
			return method.apply(context, arguments);
		};
	};
	
	var bindAll = function(context, methodNames) {
		for(var i = 0; i < methodNames.length; i++) {
			var method = context[methodNames[i]];
			context[methodNames[i]] = bind(context, method);
		}
	};
	
}());