/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.rap.export;

import java.io.InputStream;

import de.eoda.qtafi.surveymanager.rap.report.MissingData;
import de.eoda.qtafi.surveymanager.rap.report.ReportItem;

public interface Report {
	
	public static final int OPTION_NONE = 0;
	public static final int OPTION_PERCENT = 1;
	public static final int OPTION_COUNT = 2;
	public static final int OPTION_MEAN = 4;
	
	
	public static final int OPTION_TOTALS = 8;

	void appendHead(String tit, String...strings);
	void appendHead(ReportItem item, String...strings);
	
	
	void appendSubHead(String tit, String...strings);
	
	void appendFoot(String foot, String...strings);
	
	void appendTable(TabularReportData table, int options);
	void appendChart(ChartData data, int options);
	
	void appendImage(InputStream is, int options);
	
	void appendMissingInfo(MissingData data, int options);
}
