/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.rap.export;

import java.util.ArrayList;
import java.util.List;

public class TabularReportData {
	
	public List<String> colnames = new ArrayList<String>();
	public List<Row> rows = new ArrayList<Row>();
	public Row totals;
	private int colcount = 0;
	public boolean tableHead = false;
	
	public final int options;
	
	public static class Row {
		public String label;
		public Cell[] cells;
	}
	
	public static class Cell {
		public int count = 0;
		public double value = 0.;
		
		public Cell(int count, double val){
			this.count = count;
			this.value = val;
		}
	}
	
	
	public TabularReportData(int options) {
		this.options = options;
	}
	
	public void addColumnName(String colname){
		tableHead = true;
		colnames.add(colname);
	}
	
	public void addRow(String rowhead, Cell...cell){
		Row r = new Row();
		r.label = rowhead;
		r.cells = cell;
		colcount = Math.max(colcount, cell.length);
		rows.add(r);
	}
	
	public void addTotalRow(String rowhead, Cell...cell){
		totals = new Row();
		totals.label = rowhead;
		totals.cells = cell;
		colcount = Math.max(colcount, cell.length);
	}
	
	public int rowcount(){
		//return rows.size() + (header ? 1: 0);
		return rows.size();
	}
	
	public int colcount() {
		return colcount + 1;
	}

}
