/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.rap.pages;

import java.util.Locale;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import de.eoda.qtafi.surveymanager.lang.Messages;

public class CreateQuestionnaireDialog extends Dialog {


	private static final long serialVersionUID = 1L;
	String questionnairename = "";

	public CreateQuestionnaireDialog(Shell parentShell) {
		super(parentShell);
	}
	
	protected void configureShell(Shell shell) {
		super.configureShell(shell);
		shell.setText(Messages.get().Dialog_CreateQuest_NewQuest);
	}
	
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(2, false));
		
		new Label(container, SWT.NONE).setText(Messages.get().Dialog_CreateQuest_Language + ":" );
		final Combo locales = new Combo(container, SWT.READ_ONLY);
		
		final int len = Locale.getISOLanguages().length;
		
		final String[] labels = new String[len + 1];
		final String[] keys = new String[len + 1];
		labels[0] = "Default";
		keys[0] = "default";
		
		for(int i = 0; i < len; i++){
			String k = Locale.getISOLanguages()[i];
			labels[i+1] = Locale.forLanguageTag(k).getDisplayLanguage();
			keys[i+1] = k;
		}
		
		//String[] xxx = ArrayUtils.addAll(new String[]{"default" }, labels);
		
		/*
		String[] xxx = new String[Locale.getISOLanguages().length + 1];
		xxx[0] = "default";
		String[] xxx = Arrays.copyOf(Locale.getISOLanguages(), Locale.getISOLanguages().length + 1);
		xxx[Locale.getISOLanguages().length] = "default";
		*/
		locales.setItems(labels);
		locales.setText(Messages.get().Dialog_CreateQuest_Default);
		locales.select(0);
		
		questionnairename = "index.qml";
		//if(locales.getText().equals("default")) questionnairename = "index.qml";
		//else questionnairename = "index_" + locales.getText() + ".qml";
		
		locales.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				Combo b = (Combo) e.getSource();
				String lk = keys[b.getSelectionIndex()];
				if(lk.equals("default")) questionnairename = "index.qml";
				else questionnairename = "index_" + lk + ".qml";
			}
		});
		
		return container;
	}
	
	public String getValue(){
		return questionnairename;
	}
	
	
	@Override
	protected Point getInitialSize() {
		return new Point(400, 250);
	}
	
}
