/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.rap.pages;

import de.eoda.qtafi.surveymanager.lang.Messages;
import de.eoda.qtafi.surveymanager.model.Project;
import de.eoda.qtafi.surveymanager.rap.UIPage;
import de.eoda.qtafi.surveymanager.rap.UIPageContribution;
import de.eoda.qtafi.surveymanager.util.SessionResource;



public class EditorContribution implements UIPageContribution {

	private static final long serialVersionUID = 1L;

	@Override
	public String getId() {
		return "editor";
	}

	@Override
	public String getTitle() {
		Project project = SessionResource.Project();
		if(project.isOnline()) return Messages.get().Editor_Title + " (read only)";
		return Messages.get().Editor_Title;
	}

	@Override
	public UIPage createPage() {
		return new EditorPage();
	}

	@Override
	public String getIdentifier() {
		return null;
	}

}
