/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.rap.pages;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import de.eoda.qtafi.surveymanager.lang.Messages;
import de.eoda.qtafi.surveymanager.model.LibQuestion;
import de.eoda.qtafi.surveymanager.util.LibraryUtils;
import de.tinu.qtafi4.model.Question;

public class LibraryQuestionDialog extends Dialog {

	private static final long serialVersionUID = 1L;
	final Question question;
	Text subject;
	Button pub;
	int publicity = LibraryUtils.PRIVATE;
	
	public LibraryQuestionDialog(Shell parentShell, LibQuestion importquestion) {
		super(parentShell);
		this.question = importquestion.question;
		this.publicity = importquestion.visibility;
	}

	protected void configureShell(Shell shell) {
		super.configureShell(shell);
		shell.setText(Messages.get().Editor_Library);
	}
	
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container =  (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(2, true));
		
		Label subjl = new Label(container, SWT.NONE);
		subjl.setText(Messages.get().Dialog_LibraryQuest_MeanSubject);
		subjl.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		
		subject = new Text(container, SWT.BORDER);
		subject.setText(question.subject.trim());
		subject.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		
		Label publ = new Label(container, SWT.NONE);
		publ.setText(Messages.get().Dialog_LibraryQuest_Visibility);
		publ.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		
		pub = new Button(container, SWT.CHECK);
		pub.setText(Messages.get().Dialog_LibraryQuest_Public);
		pub.setSelection(publicity == LibraryUtils.PUBLIC);
		pub.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		
		return container;
	}
	
	
	@Override
	protected void okPressed() {
		question.subject = subject.getText();
		publicity = pub.getSelection() ? LibraryUtils.PUBLIC : LibraryUtils.PRIVATE;
		super.okPressed();
	}
	
	public int getPublicity(){
		return publicity;
	}
	
	public Question getQuestion(){
		return question;
	}
	
	@Override
	protected Point getInitialSize() {
		return new Point(650, 400);
	}
}
