/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.rap.pages;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import de.eoda.qtafi.surveymanager.lang.Messages;
import de.eoda.qtafi.surveymanager.util.SessionResource;
import de.tinu.qtafi4.model.QuestionnaireOptions;

public class QuestionnaireOptionsDialog extends Dialog{
	
	private static final long serialVersionUID = 1L;
	
	final String filename;
	final QuestionnaireOptions options;

	protected QuestionnaireOptionsDialog(Shell parentShell, String filaname) {
		super(parentShell);
		this.filename = filaname;
		
		options = SessionResource.QuestionDB(this.filename).getOptions();
	}
	
	protected void configureShell(Shell shell) {
		super.configureShell(shell);
		shell.setText(Messages.get().Dialog_QuestOptions_Title);
	}
	
	
	@Override
	protected Control createDialogArea(Composite parentt) {
		Composite container = (Composite) super.createDialogArea(parentt);
		container.setLayout(new GridLayout(2, true));
		
		Label label = new Label(container, SWT.NONE);
		label.setText(Messages.get().Dialog_QuestOptions_TextDirection);
		label.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		
		
		final Button pagedir = new Button(container, SWT.CHECK);
		pagedir.setText(Messages.get().Dialog_QuestOptions_RightToLeft);
		pagedir.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		pagedir.setSelection(options.pagedir.equals("rtl"));
		
		pagedir.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				if(pagedir.getSelection()) options.pagedir = "rtl";
				else options.pagedir = "ltr";
			}
		});
		return container;
	}

	
	@Override
	protected void okPressed() {
		
		SessionResource.QuestionDB(this.filename).setOptions(options);
		super.okPressed();
	}
	
}
