/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.rap.pages;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import de.eoda.qtafi.surveymanager.lang.Messages;
import de.eoda.qtafi.surveymanager.rap.report.ReportItem;

public class ReportPropertyDialog extends Dialog {

	private static final long serialVersionUID = 1L;
	
	final ReportItem report;
	public ReportPage reportpage = null;
	
	
	public ReportPropertyDialog(Shell parentShell, ReportItem report) {
		super(parentShell);
		this.report = report;
	}

	protected void configureShell(Shell shell) {
		super.configureShell(shell);
		shell.setText(Messages.get().Dialog_ReportProperty_Title);
	}
	
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container =  (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(2, false));
		report.createDialog(container);
	
		Label label = new Label(container, SWT.NONE);
		label.setText("");
		
		Button apply = new Button(container, SWT.PUSH);
		apply.setText(Messages.get().ReportPage_ApplyToAll);
		apply.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				if(reportpage != null) reportpage.applyToAll(report);
			}
		});
		
		return container;
	}
	
	
	@Override
	protected void okPressed() {
		report.onOk();
		super.okPressed();
	}
	
	@Override
	protected void cancelPressed() {
		report.onCancel();
		super.cancelPressed();
	}
	
	@Override
	protected Point getInitialSize() {
		return new Point(650, 600);
	}
	
}
