/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.rap.pages;


import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.TraverseEvent;
import org.eclipse.swt.events.TraverseListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import de.eoda.qtafi.surveymanager.lang.Messages;

public class TextDialog extends Dialog {

	private static final long serialVersionUID = 1L;
	
	Text input;
	String inputtext = null;
	
	public TextDialog(Shell parent) {
		super(parent);
	}
	
	public TextDialog(Shell parent, String initialText) {
		super(parent);
		this.inputtext = initialText;
	}
	
	protected void configureShell(Shell shell) {
		super.configureShell(shell);
		shell.setText(Messages.get().Dialog_Text_Title);
	}
	
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout());
		input = new Text(container, SWT.BORDER | SWT.MULTI);
		input.addKeyListener(new KeyAdapter() {
			@Override
			public void keyPressed(KeyEvent e) {
				if(e.stateMask == 0 && e.keyCode == SWT.TAB) {
					input.insert(new Character(SWT.TAB).toString());
				}
			}
		});
		input.addTraverseListener(new TraverseListener() {
			public void keyTraversed(TraverseEvent e) {
				if(e.detail == SWT.TRAVERSE_TAB_NEXT || e.detail == SWT.TRAVERSE_TAB_PREVIOUS) {
					e.doit = false;
					e.detail = SWT.TRAVERSE_NONE;
				}
				input.setFocus();
			}
		});
		
		if(inputtext != null) input.setText(inputtext);
		input.setLayoutData(new GridData(GridData.FILL_BOTH));
		return container;
	}
	
	@Override
	protected void okPressed() {
		inputtext = input.getText();
		super.okPressed();
	}
	
	public String getText(){
		return inputtext;
	}
	
	@Override
	protected Point getInitialSize() {
		return new Point(450, 500);
	}

}
