/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.rap.report;

import java.util.Arrays;


public class Address implements Comparable<Address> {

	public final AddressTuple[] parts;
	
	
	public Address(AddressTuple t) {
		this.parts = new AddressTuple[]{t};
	}
	
	public Address(AddressTuple...t) {
		Arrays.sort(t);
		this.parts = t;
	}
	
	public Address clone(){
		AddressTuple[] newparts = Arrays.copyOf(parts, parts.length);
		return new Address(newparts);
	}
	
	public Address parse(String x){
		return new Address();
	}
	
	
	public String getRepresentation() {
		if(parts == null) return "";
		return Arrays.toString(parts);
	}
	
	public String getRequestRepresentation() {
		if(parts == null) return "";
		StringBuffer b = new StringBuffer();
		for(AddressTuple a: parts){
			if(a.val.equals("*")) b.append(a.var+":*;");
			else  b.append(a.var + ";");
			//if(! a.val.equals("*")) b.append(a.var + ";");
		}
		return b.toString();
	}
	
	
	@Override
	public boolean equals(Object obj) {
		if(obj instanceof Address) return this.getRepresentation().equals(((Address) obj).getRepresentation());
		return this.getRepresentation().equals(obj.toString());
	}
	
	@Override
	public int compareTo(Address o) {
		return this.getRepresentation().compareTo(o.getRepresentation());
	}
	
	@Override
	public String toString() {
		return getRepresentation();
	}

}
