/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.rap.report;

public class AddressTuple implements Comparable<AddressTuple> {

	
	public final String var;
	public final String val;

	public AddressTuple(String var, String val) {
		this.var = var;
		if(val == null) this.val = "-9";
		else if(val.trim().equals("")) this.val = "-9";
		else this.val = val;
	}
	
	public boolean isMissing(){
		return val.equals("-9");
	}
	
	public AddressTuple getWildcard() {
		if(val.equals("-9")) return new AddressTuple(var, "~");
		return new AddressTuple(var, "*");
	}
	
	@Override
	public int compareTo(AddressTuple o) {	
		int c = var.compareTo(o.var);
		if(c == 0) return val.compareTo(o.val);
		return c;
	}
	
	@Override
	public int hashCode() {
		return toString().hashCode();
	}
	
	public String toString(){
		return this.var+":"+this.val;
	}
	
}
