/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.rap.report;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import de.eoda.qtafi.surveymanager.lang.Messages;
import de.eoda.qtafi.surveymanager.rap.export.Report;
import de.tinu.qtafi4.model.Question;

public class HLReportItem extends ReportItem {

	private static final long serialVersionUID = 1L;
	
	Text titleInput;

	public HLReportItem(Composite parent, int style, Question q) {
		super(parent, style, q);
	}
	
	@Override
	public void createDialog(Composite parent){
		Label titlelabel = new Label(parent, SWT.NONE);
		titlelabel.setText(Messages.get().ReportPage_Title);
		titlelabel.setLayoutData(new GridData(200, 22));
		
		titleInput = new Text(parent, SWT.BORDER);
		titleInput.setEditable(false);
		titleInput.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		titleInput.setText(this.title);
	}
	
	@Override
	public void onOk() {
		this.title = titleInput.getText();
	}

	@Override
	public void toDocument(Report doc) {
		doc.appendHead(this.title);
	}
	
}
