/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.util;

import java.io.IOException;
import java.util.List;
import java.util.Vector;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.eclipse.rap.rwt.service.ServiceHandler;

public class DblClickHandler implements ServiceHandler {

	public static final String DBLCLICK = "dblclick";
	
	
	public static interface DblClickCallback {

		void dblClicked(HttpServletRequest request);
	}
	
	private static DblClickHandler instance;
	
	public static DblClickHandler getInstance(){
		if(instance == null) instance = new DblClickHandler();
		return instance;
	}
	
	private List<DblClickCallback> callbacks = new Vector<DblClickCallback>();
	
	public void addDblClickCallback(DblClickCallback dd){
		callbacks.add(dd);
	}
	
	@Override
	public void service(HttpServletRequest request, HttpServletResponse response)
			throws IOException, ServletException {
		
		for(DblClickCallback cb: callbacks){
			cb.dblClicked(request);
		}
		
		response.getOutputStream().write("OK".getBytes());
		response.getOutputStream().flush();
		response.getOutputStream().close();
	}

}
