/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.util;

import org.eclipse.rap.rwt.RWT;

import de.eoda.qtafi.surveymanager.model.Project;
import de.tinu.qtafi4.db.QuestionDBImpl;

public class SessionResource {

	
	public static de.tinu.qtafi4.db.QuestionDB QuestionDB(String qml){
		Project project = (Project) RWT.getUISession().getHttpSession().getAttribute("project");
		if(project == null) throw new IllegalArgumentException("Project not set");
		
		de.tinu.qtafi4.db.QuestionDB questiondb = (de.tinu.qtafi4.db.QuestionDB) RWT.getUISession().getHttpSession().getAttribute("questiondb");
		
		if(questiondb == null){
			questiondb = new QuestionDBImpl();
			questiondb.init(project.name, Resources.ProjectResource(project.name, qml).getAbsolutePath());
		}
		return questiondb;
	}
	
	public static de.eoda.qtafi.surveymanager.model.Project Project(){
		Project project = (Project) RWT.getUISession().getHttpSession().getAttribute("project");
		return project;
	}
}
