/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.eoda.qtafi.surveymanager.util;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

public class XSLTProcessor {

	
	public static void main(String...args) throws Exception {
		process(new FileInputStream("/home/maks/java/qtafi/mtmelsungen.qml"), 
				new FileOutputStream("/home/maks/java/qtafi/out.qml"));
	}
	
	public static void process(InputStream in, OutputStream os, String xslt){
		try {
			TransformerFactory transfac = TransformerFactory.newInstance();
			Transformer trans = transfac.newTransformer(new StreamSource(xslt));
			trans.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION,"yes");
			trans.setOutputProperty(OutputKeys.METHOD,"xml");
			StreamResult result = new StreamResult(os);
			Source source = new StreamSource(in);
			trans.transform(source, result);
		}
		catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
	public static void process(InputStream in, OutputStream os){
		try {
			TransformerFactory transfac = TransformerFactory.newInstance();
			Transformer trans = transfac.newTransformer(new StreamSource(
					XSLTProcessor.class.getClassLoader().getResourceAsStream("de/eoda/qtafi/surveymanager/util/import.xslt")));
			trans.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
			trans.setOutputProperty(OutputKeys.METHOD,"xml");
			StreamResult result = new StreamResult(os);
			Source source = new StreamSource(in);
			trans.transform(source, result);
		}
		catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}
