<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:qtafi="urn:qtafi">
	<xsl:output method="xml" version="1.0" indent="yes" omit-xml-declaration="yes" encoding="UTF-8" />


	<xsl:template match="/">
		<xsl:copy>
			<xsl:apply-templates />
		</xsl:copy>
	</xsl:template>

	<xsl:template match="children">
		<xsl:copy>
			<xsl:apply-templates />
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="codebook|qtafi">
		<xsl:copy>
			<xsl:apply-templates />
		</xsl:copy>
	</xsl:template>

	<xsl:template match="TL">
		<TE>
			<xsl:if test="not(@uid)">
				<xsl:attribute name="uid"><xsl:value-of select="generate-id()" /></xsl:attribute>
			</xsl:if>
			<xsl:if test="@id">
				<xsl:attribute name="id"><xsl:value-of select="@id" /></xsl:attribute>
			</xsl:if>
			<xsl:apply-templates />
		</TE>
	</xsl:template>

	<xsl:template match="CV|MD|OR|TE|ME|HL">
		<xsl:copy>
			<xsl:if test="not(@uid)">
				<xsl:attribute name="uid"><xsl:value-of select="generate-id()" /></xsl:attribute>
			</xsl:if>
			<xsl:if test="@id">
				<xsl:attribute name="id"><xsl:value-of select="@id" /></xsl:attribute>
			</xsl:if>
			<xsl:if test="not(subject)">
				<subject>
					<xsl:value-of select="text" />
				</subject>
			</xsl:if>
			<xsl:apply-templates />
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="XHTML|RAW|NavigationButton|ProgressBar">
	</xsl:template>
	
	<xsl:template match="filter|code">
	</xsl:template>
	
	<xsl:template match="comment()">
	</xsl:template>
	
	<xsl:template match="number|text|moretext|variable|value|subject">
		<xsl:copy>
			<xsl:apply-templates select="@* | node()"/>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="@* | node()">
    	<xsl:copy>
      		<xsl:apply-templates select="@* | node()"/>
    	</xsl:copy>
	</xsl:template>
	
	<xsl:template match="text()">
		<xsl:copy />
	</xsl:template>
	
	<xsl:template match="Page|Head|Foot">
		<xsl:copy> 
			<xsl:if test="not(@uid)">
				<xsl:attribute name="uid"><xsl:value-of select="generate-id()" /></xsl:attribute>
			</xsl:if>
			<xsl:apply-templates />
		</xsl:copy>
	</xsl:template>

	
</xsl:stylesheet>
