
var page   = require('webpage').create(),
    fs     = require('fs'),
    system = require('system'),
    output, size;

if (system.args.length === 1) {
    console.log('Try to pass some args when invoking this script!');
} 
else {
    system.args.forEach(function (arg, i) {
      console.log(i + ': ' + arg);
    });
}

page.onResourceReceived = function(response) {
  console.log(response.url);
};

page.onResourceRequested = function(requestData, request) {
  console.log('::loading', requestData['url']);  // this does get logged now
};

page.onConsoleMessage = function(msg){
    console.log(msg);
};

page.onError = function(msg, trace) {
  var msgStack = ['ERROR: ' + msg];
  if (trace && trace.length) {
    msgStack.push('TRACE:');
    trace.forEach(function(t) {
      msgStack.push(' -> ' + t.file + ': ' + t.line + (t.function ? ' (in function "' + t.function +'")' : ''));
    });
  }
  console.error(msgStack.join('\n'));
};

page.onLoadFinished = function() {
    console.log('::rendering');
    page.injectJs('d3.min.js');
    page.injectJs('c3.min.js');

    var inputfile = system.args[1];

    var cc = fs.read(inputfile);
    var chartdata = eval('(' + cc + ')');
    chartdata.bindto = "#graph";

    page.evaluate(function(chartdata) {
        var chart = c3.generate(chartdata);
    }, chartdata);
  
    //fs.write('test.html', page.content, 'w');
    //page.render('test.png');
    //phantom.exit();
    setTimeout(function() {
      page.render(inputfile +'.png');
      phantom.exit();
    }, 300);
};

page.content = fs.read("export.html");
