//<!--
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2011 Martin Guist guist.incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

function onEnter(event){     
      var code = event.keyCode;
      if(code == 13){
    	  login();
      }
};

function validateEmail(email){
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
};

var filters = {};
var listeners = {};

function filter(quid, filterobj){
	if(! filters[quid]) filters[quid] = [];
	filters[quid].push(filterobj);
};

function notifyValueChanged(variable, value){
	for(var key in filters){
		evalFilter(key, false);
	}
};

function initFilter(quid){
	evalFilter(quid, true);
};

function evalFilter(quid, initial){
	var res = evalObjects(quid);
	//console.log("evalObjects  " + quid + " -> " + res);
	if(res == 'undefined') return;
	if(res == false) hideQuestion('TA_'+quid, initial);
	else showQuestion('TA_'+quid, initial);
};

function evalObjects(quid){
	if(! filters[quid]) return;
	var ignore = true;
	for(var i = 0; i < filters[quid].length; i++){
		var fs = filters[quid][i];
		for(var j = 0; j < fs.length; j++){
			var f = fs[j]; 
			//console.log(f);
			if(f.type == "ignore_if" || f.type == "hide_if"){
				var res = evalObject(f);
				ignore = true;
				if(res) return false;
			}
			else if(f.type == "ignore_group" || f.type == "hide_group"){
				var res = evalGroup(f);
				ignore = true;
				if(res) return false;
			}
			else if(f.type == "use_if" || f.type == "show_if"){
				var res = evalObject(f);
				//console.log("eval " +f.type + " " + f.variable + " -> " + res);
				ignore = false;
				if(res) return true;
			}
			else if(f.type ==  "use_group" || f.type == "show_group"){
				var res = evalGroup(f);
				//console.log("eval group " +f.type + " " + f.condition + " -> " + res);
				ignore = false;
				if(res) return true;
			}
		}
	}
	return ignore;
};

function evalGroup(obj){
	var condition = "OR";
	if(obj.condition) condition = obj.condition;
	var result = true;
	if(condition == "NOT"){
	}
	for(var i = 0; i < obj.children.length; i++){
		var f = obj.children[i];
		if(f.type == "use_if" || f.type == "ignore_if" || f.type == "show_if" || f.type == "hide_if"){
			var res = evalObject(f);
			//console.log("eval " +f.type + " " + f.variable + "=" +f.value + " -> " + res + " (" + condition + ")" + (condition == "OR") );
			var thisnum = res?1:0;
			if(condition == "AND"){
				if(!(result && res)) return false;
			}
			else if(condition == "NAND"){
				if(! res) return true;
			}
			else if(condition == "NOR"){
				if(res) return false;
			}
			else if(condition == "OR") {
				console.log("return OR " + res);
				if(res) return true;
			}
			else if(condition == "XOR"){
				if(numresult < 0){
					result = res;
					numresult = thisnum;
					continue;
				}
				if(numresult != thisnum){
					return true;
				}
			}
			result = res;
			numresult = thisnum;
		}
		else if(f.type == "use_group" || f.type == "show_group" || f.type == "hide_group" || f.type == "ignore_group" || f.type == "filter_group"){
			var res = evalGroup(f);
			//console.log("eval group " +f.type + " " + f.condition + " -> " + res);
			var thisnum = res?1:0;
			if(condition == "AND") if(!(result && res)) return false;
			else if(condition == "NAND")if(! res) return true;
			else if(condition == "NOR") if(res) return false;
			else if(condition == "OR") if(res) return true;
			else if(condition == "XOR"){
				if(numresult < 0){
					result = res;
					numresult = thisnum;
					continue;
				}
				if(numresult != thisnum){
					return true;
				}
			}
			result = res;
			numresult = thisnum;
		}
	}
	if(condition == "AND") return true;
	if(condition == "NAND") return false;
	if(condition == "OR") return false;
	if(condition == "NOR") return true;
	if(condition == "XOR") return false;
	return false;
};

function evalObject(obj){
	var variable = obj.variable;
	var value = obj.value;
	var operator = "IS";
	if(obj.operator) operator = obj.operator;
	return compareValue(variable, value, operator);
};

function compareValue(variable, value, operator){
	var val1 = getVariable(variable); 
	var val2 = value;
	switch(operator){
		case 'IS': return val1 == val2;
		case 'IS_IGNORE_CASE': return val1.toLowerCase() == val2.toLowerCase();
		case 'IS_NOT': return val1 != val2;
		case 'LESS_THAN': return val1 < val2;
		case 'LESS_OR_EQUAL_THAN': return val1 <= val2;
		case 'GREATER_THAN': return val1 > val2;
		case 'GREATER_OR_EQUAL_THAN': return val1 >= val2;
	}
	return false;
};

function login(){
	document.qtafi2.action = document.qtafi2.action + "?login=true";
	document.qtafi2.submit();
};

/**
*
*/
var cv_values = new Object();
var cv_hierachy = new Object();

function getVariable(varstr){
	if(document.qtafi2[varstr]){
		return String(document.qtafi2[varstr].value);
	}
	return String("-9");
}

function setVariable(varstr, valstr){
	if(document.qtafi2[varstr]){
		document.qtafi2[varstr].value = valstr;
	}
}

/**
* does not allow .,
*/
function checkInteger(evt, decimal){
	var charCode = (evt.which) ? evt.which : event.keyCode;
	return ( (charCode >= 48 && charCode <= 57) || charCode < 32 || charCode == 44 || charCode == 46 );
}


/**
* arguments[0] = var
* arguments[1] = not selected value
* arguments[2] = selected value
* arguments[3] = number
*/
function toggle_CV(){
	var vname = arguments[0];
	var vnum = arguments[2];
	if( document.forms["qtafi2"].elements[arguments[0]].value == arguments[2] ){
		document.forms["qtafi2"].elements["__"+arguments[0]][arguments[3]].checked = false;
		document.forms["qtafi2"].elements[arguments[0]].value = arguments[1];
	}
	else{
		document.forms["qtafi2"].elements[arguments[0]].value = arguments[2];
	}
	valueChanged(arguments[0]);
	notifyValueChanged(arguments[0], document.forms["qtafi2"].elements[arguments[0]].value);
}

function getCategoryLevel(){
	var level = 0;
	if( ! arguments[0][arguments[1]] ) return -1;
	if( arguments[0][arguments[1]] == "__none" ) return 0;
	var t = arguments[0][arguments[1]];
	while( t != "__none" ){
		t = arguments[0][t];
		level++;
		if(level == 10) return -1;
	}
	return level;
}

/**
* arguments[0] = var
* arguments[1] = tempvar
*/
function selectCategory(){
	var selectedvalue = document.forms["qtafi2"].elements[arguments[1]].value;
	document.forms["qtafi2"].elements[arguments[0]].value = selectedvalue;
	
	var l = getCategoryLevel( cv_hierachy[arguments[0]], selectedvalue );
	if( l < 0 ) return;
	for( var n = l; n < 2; n++){
		var levelid = arguments[0] + "_L" + (n+1);
		if( document.getElementById( levelid ) ){
			document.getElementById( levelid ).innerHTML = " ";
		}
	}
	
	var vvv = selectedvalue;
	var levelid = arguments[0] + "_L" + (l+1);
	if(cv_values[arguments[0]][vvv]){
		document.getElementById( levelid ).innerHTML = cv_values[arguments[0]][vvv].replace( /%%%/g, '\"');
		document.forms["qtafi2"].elements["__"+arguments[0]+"_"+vvv].value = vvv;
	}
	else {
		if(document.getElementById(levelid)) document.getElementById( levelid ).innerHTML = " ";
	}
}

/**
* arguments[0] = var
* arguments[1] = temp
*/
function initCategory(){
	var selectedvalue = document.forms["qtafi2"].elements[arguments[0]].value;

	var l = getCategoryLevel(cv_hierachy[arguments[0]], selectedvalue);
	if(l < 0) return;
	var vvv = selectedvalue;

	for( var i = 0; i< 5; i++ ){
		var levelid = arguments[0] + "_L" + l;
		var ddd = cv_hierachy[arguments[0]][vvv];
		if( cv_values[arguments[0]][ddd] ){
			document.getElementById( levelid ).innerHTML = cv_values[arguments[0]][ddd].replace( /%%%/g, '\"');
		}
		if(document.forms["qtafi2"].elements["__"+arguments[0]+"_"+ddd]){
			document.forms["qtafi2"].elements["__"+arguments[0]+"_"+ddd].value = vvv;
			for(var oi = 0; oi < document.forms["qtafi2"].elements["__"+arguments[0]+"_"+ddd].length; oi++ ){
				if(document.forms["qtafi2"].elements["__"+arguments[0]+"_"+ddd].options[oi].value == vvv){
					document.forms["qtafi2"].elements["__"+arguments[0]+"_"+ddd].selectedIndex = oi;
					break;
				}
			}
		}
		if( ! cv_hierachy[arguments[0]][vvv] ) return;
		vvv = cv_hierachy[arguments[0]][vvv];
		l--;
	}
}

var scroll_y = 0;
function popup_CV(ev, cvnr){
	scroll_y = getScrollXY()[1];
	$('#'+cvnr+'_popup').fadeIn('slow');
	window.scrollTo(0,0);
}

function popdown_CV(cvvar, cvnr){
	$('#'+cvnr+'_popup').fadeOut('slow');
	var sel = getVariable(cvvar);
	var selected = document.getElementById('value_'+cvvar+'_'+sel);
	if(selected){
		$('input[type=text]').each(function(index, para) {
			$(this).attr('value', $(this).val());
		});
		document.getElementById(cvnr + '_show').innerHTML = $('#value_'+cvvar+'_'+sel).html();
	}
	else document.getElementById(cvnr + '_show').innerHTML = "<span />";
	window.scrollTo(0, scroll_y);
}

function init_popup(cvnr){
	$('#'+cvnr+'_popup').hide();
}

function getScrollXY(){
	var scrOfX = 0, scrOfY = 0;
	if(typeof(window.pageYOffset) == 'number'){
		//Netscape compliant
		scrOfY = window.pageYOffset;
		scrOfX = window.pageXOffset;
	}
	else if(document.body && (document.body.scrollLeft || document.body.scrollTop)){
		//DOM compliant
		scrOfY = document.body.scrollTop;
		scrOfX = document.body.scrollLeft;
	}
	else if(document.documentElement && (document.documentElement.scrollLeft || document.documentElement.scrollTop)){
		//IE6 standards compliant mode
		scrOfY = document.documentElement.scrollTop;
		scrOfX = document.documentElement.scrollLeft;
	}
	return [scrOfX, scrOfY];
}


/**
* arguments[0] = var
* arguments[1] = not selected value
* arguments[2] = selected value
*/
function toggle_MD(){
	if(document.forms["qtafi2"].elements["__"+arguments[0]].checked == true){
		document.forms["qtafi2"].elements[arguments[0]].value = arguments[2];
	}
	else{ 
		document.forms["qtafi2"].elements[arguments[0]].value = arguments[1];
	}
	valueChanged(arguments[0]);
	notifyValueChanged(arguments[0], document.forms["qtafi2"].elements[arguments[0]].value);
}

/**
* arguments[0] = var
* arguments[1] = not selected value
* arguments[2] = selected value
* arguments[3] = number
*/
function toggle_OR(){
	var vname = arguments[0];
	var vnum = arguments[2];
	if( document.forms["qtafi2"].elements[arguments[0]].value == arguments[2] ){
		document.forms["qtafi2"].elements["__"+arguments[0]][arguments[3]].checked = false;
		document.forms["qtafi2"].elements[arguments[0]].value = arguments[1];
	}
	else{
		document.forms["qtafi2"].elements[arguments[0]].value = arguments[2];
	}
	valueChanged(arguments[0]);
	notifyValueChanged(arguments[0], document.forms["qtafi2"].elements[arguments[0]].value);
}

/**
* arguments[0] = var
* arguments[1] = value
*/
function set_value(){
	if( document.forms["qtafi2"].elements[arguments[0]] ){
		document.forms["qtafi2"].elements[arguments[0]].value = arguments[1];
	}
	if( document.forms["qtafi2"].elements["__"+arguments[0]] ){
		if( document.forms["qtafi2"].elements["__"+arguments[0]][0] ){//array
			if( document.forms["qtafi2"].elements["__"+arguments[0]][0].type == "radio" ){
				for( var i = 0; i < document.forms["qtafi2"].elements["__"+arguments[0]].length; i++ ){
					if( arguments[1] == '-9' ){
						document.forms["qtafi2"].elements["__"+arguments[0]][i].checked = false;
					}
					else{
						if( document.forms["qtafi2"].elements["__"+arguments[0]][i].value == arguments[1] ){
							document.forms["qtafi2"].elements["__"+arguments[0]][i].checked = true;
						}
					}
				}
			}
		}
		else {//kein array
			if( document.forms["qtafi2"].elements["__"+arguments[0]].type == "checkbox" ){//MD
				if( arguments[1] == '-9' ){
					document.forms["qtafi2"].elements["__"+arguments[0]].checked = false;
				}
				else if( document.forms["qtafi2"].elements["__"+arguments[0]].value == arguments[1] ){
					document.forms["qtafi2"].elements["__"+arguments[0]].checked = true;
				}
			}
			else {
				document.forms["qtafi2"].elements["__"+arguments[0]].value = arguments[1];
			}
		}
	}
	valueChanged(arguments[0]);
}

/**
* arguments[0] = the question id or <element-id>|<html-id>
* arguments[1] = variable to send with request
* arguments[2] = variable to send with request
* variable to send with request
*/
function loadElement(){
	var httpRequest;
	var nodeid = arguments[0];
	if(arguments[0].search(/\|/) != -1) nodeid = arguments[0].split("|")[1];
	if(window.XMLHttpRequest){ //Mozilla, Safari, ...
		httpRequest = new XMLHttpRequest();
	} 
	else if(window.ActiveXObject){ //IE
		httpRequest = new ActiveXObject("Microsoft.XMLHTTP");
	}
	
	httpRequest.onreadystatechange = function(){
		if(httpRequest.readyState == 4){//complete
			if(nodeid){
				var node = document.getElementById(nodeid);
				node.innerHTML = httpRequest.responseText;
				evalScript(httpRequest.responseText);
			}
		}
	};
	
	var postrequest = "";
	for(var i = 1; i < (arguments.length); i++){
		if(document.forms["qtafi2"].elements[arguments[i]]){
			postrequest += '&'+arguments[i]+'='+document.forms["qtafi2"].elements[arguments[i]].value;
		}
	}
	var path = location.href;
	var async_path = path.replace(/projects/g, "async");
	httpRequest.open('POST', async_path+'/?id=' + arguments[0], true);
	httpRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	httpRequest.send('__async=true&__id='+document.qtafi2.__id.value+'&__project='+document.qtafi2.__project.value +'&__page='+document.qtafi2.__page.value+'&__requestpage='+document.qtafi2.__page.value+'&'+postrequest );
}

function reloadElement(){
	var httpRequest;
	var nodeid = arguments[0];
	
	if(window.XMLHttpRequest){ //Mozilla, Safari, ...
		httpRequest = new XMLHttpRequest();
	} 
	else if(window.ActiveXObject){ //IE
		httpRequest = new ActiveXObject("Microsoft.XMLHTTP");
	}
	
	httpRequest.onreadystatechange = function(){
		if(httpRequest.readyState == 4){//complete
			if(nodeid){
				var node = document.getElementById(nodeid);
				node.innerHTML = httpRequest.responseText;
				evalScript(httpRequest.responseText);
			}
		}
	};
	
	var postrequest = "";
	for(var i = 1; i < (arguments.length); i++){
		if(document.forms["qtafi2"].elements[arguments[i]]){
			postrequest += '&'+arguments[i]+'='+document.forms["qtafi2"].elements[arguments[i]].value;
		}
	}
	var path = location.href;
	alert(path);
	var async_path = path;
	httpRequest.open('POST', async_path+'?__async=true&id=' + arguments[0], true);
	httpRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	httpRequest.send(postrequest);
}

function evalScript(scripts){
	try {	
		if(scripts != ''){	
			var script = "";
			scripts = scripts.replace(/<script[^>]*>([\s\S]*?)<\/script>/gi, function(){
				if(scripts !== null) script += arguments[1] + '\n'; return '';});
				if(script) (window.execScript) ? window.execScript(script) : window.setTimeout(script, 0);
		}
		return false;
	}
	catch(e){	
		alert(e);
	}
}

/**
* toggles the visibility of the element (space is required)
*
* argument[0] = the element id
*/
function toggle_visibility(nr){
	if (document.layers){
		vista = (document.layers[nr].visibility == 'hide') ? 'show' : 'hide';
		document.layers[nr].visibility = vista;
	}
	else if (document.all){
		vista = (document.all[nr].style.visibility == 'hidden') ? 'visible'	: 'hidden';
		document.all[nr].style.visibility = vista;
	}
	else if (document.getElementById){
		vista = (document.getElementById(nr).style.visibility == 'hidden') ? 'visible' : 'hidden';
		document.getElementById(nr).style.visibility = vista;
	}
}

/**
* arguments[0] = question element (not variable)
* arguments[1] = init true | false
*/
function hideQuestion(){
	if(arguments[1]){//initation
		if(document.getElementById(arguments[0])){
			jQuery('#'+arguments[0]).hide();
		}
	}
	else {
		if(navigator.appVersion.search(/MSIE 6.0/) > 0 ){
			if(document.getElementById(arguments[0])){
				jQuery('#'+arguments[0]).hide();
			}
		}
		else{
			if(document.getElementById(arguments[0])){
				//$('#'+arguments[0]).slideUp('slow');
				jQuery('#'+arguments[0]).fadeOut('slow');
			}
		}
	}
}

function showQuestion(){
	if(arguments[1]){
		if(document.getElementById(arguments[0])){
			jQuery('#'+arguments[0]).show();
		}
	}
	else {
		if(navigator.appVersion.search(/MSIE 6.0/) > 0){
			if(document.getElementById(arguments[0])){
				jQuery('#'+arguments[0]).show();
			}
		}
		else {
			if(document.getElementById(arguments[0])){
				//$('#'+arguments[0]).slideDown('slow');
				jQuery('#'+arguments[0]).fadeIn('slow');
			}
		}
	}
}

function activate(){
	jQuery('#'+arguments[0]).fadeTo('slow', 1.0);
}

function deactivate(){
	jQuery('#'+arguments[0]).fadeTo('slow', 0.5);
}

/**
* arguments[0] = variable
*/
function enableVariable(){
	if( document.forms["qtafi2"].elements[arguments[0]]){
		if( document.forms["qtafi2"].elements[arguments[0]].type != "hidden" ){
			document.forms["qtafi2"].elements[arguments[0]].disabled = false;
		}
		if( document.forms["qtafi2"].elements['__'+arguments[0]] ){
			if( document.forms["qtafi2"].elements['__'+arguments[0]][0] ){//Array
				for( var i = 0; i < document.forms["qtafi2"].elements['__'+arguments[0]].length; i++ ){
					document.forms["qtafi2"].elements['__'+arguments[0]][i].disabled = false;
				}
			}
			else {
				document.forms["qtafi2"].elements['__'+arguments[0]].disabled = false;
			}
		}
	}
}

function disableVariable(){
	if( document.forms["qtafi2"].elements[arguments[0]]){
		if( document.forms["qtafi2"].elements[arguments[0]].type != "hidden" ){
			document.forms["qtafi2"].elements[arguments[0]].disabled = true;
		}
		if( document.forms["qtafi2"].elements['__'+arguments[0]] ){
			if( document.forms["qtafi2"].elements['__'+arguments[0]][0] ){//Array
				for( var i = 0; i < document.forms["qtafi2"].elements['__'+arguments[0]].length; i++ ){
					document.forms["qtafi2"].elements['__'+arguments[0]][i].disabled = true;
				}
			}
			else{
				document.forms["qtafi2"].elements['__'+arguments[0]].disabled = true;
			}
		}
	}
}

/**
* arguments[0] = url
* arguments[1] = width
* arguments[2] = height
*/
function smallWindow(){
	if(arguments[1] && arguments[2]){
		window.open(arguments[0], "smallWindow", "width="+arguments[1]+", height="+arguments[2]+", left=100, top=100, scrollbars=no");
	}
	else{
		window.open(arguments[0], "smallWindow", "width=550, height=450, left=100, top=100, scrollbars=yes");
	}
}

/**
* Date Utils
*
*/
function lastsOn(absmonth){
	return (absmonth == '9999');
};

function getMonth(absmonth){
	var month = parseInt(absmonth);
	return ((month%12)+1);
};

function getYear(absmonth){
	var year = parseInt(absmonth);
	return parseInt(year / 12)+1950;
};

/**
*
*
*
* ValueListenerObject = function(){ }
* ValueListenerObject.prototype.checkInput = function(){
*	return confirm("mach was ");
* }
* attachValidater( new ValidaterObject() );
*
*/

/**
* Example
* 
*  
*  listen("A1" function(){
*  })
* 
* @param variable
* @param func
*/
function listen(variable, func){
	//alert("listen " + variable)
	//$("input[name="+variable+"]").change(function(){
		//func.call(this);
	//});
	detachVariableListener(variable, func);
	if(! variableListener[variable]){
		variableListener[variable] = new Array();
		variableListener[variable].push(func);
	}
	else{
		variableListener[variable].push(func);
	}
}

var variableListener = new Array();
/**
* arguments[0] = the variable
* arguments[1] = the ListenerObject
*
* VariableListenerObject = function(){ }
* VariableListenerObject.prototype.notifyVariableChanged = function(var, val, init){
*	alert("changed");
* };
* attachVariableListener(variable, new VariableListenerObect());
*/


function attachVariableListener(){
	detachVariableListener(arguments[0], arguments[1]);
	if(! variableListener[arguments[0]]){
		variableListener[arguments[0]] = new Array();
		variableListener[arguments[0]].push(arguments[1]);
	}
	else{
		variableListener[arguments[0]].push(arguments[1]);
	}
}
function detachVariableListener(){
	if(variableListener[arguments[0]]){
		var newlistener = new Array();
		for(var i= 0; i < variableListener[arguments[0]].length; i++){
			if(variableListener[arguments[0]][i] != arguments[1]) newlistener.push(variableListener[arguments[0]][i]);
		}
		variableListener[arguments[0]] = newlistener;
	}
}
/**
* arguments[0] = variable which has changed
* has to be called whenever a variable was changed
* prevent recursion
*/
function valueChanged(){
	//$("input[name="+arguments[0]+"]").change();
	//notifyListener(arguments[0]);
}

var ontherun = 0;

function notifyListener(){
	if(ontherun > 2) return
	ontherun++;
	var varchanged = arguments[0];
	var changedvalue = getVariable(varchanged);
	if(variableListener[arguments[0]]){
		for(var i = 0; i < variableListener[arguments[0]].length; i++){
			if(variableListener[arguments[0]][i]){
				var f = variableListener[arguments[0]][i];
				if(typeof(f)=='function') f();
				else f.notifyVariableChanged(arguments[0], changedvalue, false);
			}
		}
	}
	ontherun = 0;
}
/*
function notifyListener(){
	if(ontherun > 2) return
	ontherun++;
	var varchanged = arguments[0];
	var changedvalue = getVariable(varchanged);
	if(variableListener[arguments[0]]){
		for(var i = 0; i < variableListener[arguments[0]].length; i++){
			if(variableListener[arguments[0]][i]){
				variableListener[arguments[0]][i].notifyVariableChanged(arguments[0], changedvalue, false);
			}
		}
	}
	ontherun = 0;
}
*/

function proceed(incr){
	if(document.qtafi2.onsubmit &&  ! document.qtafi2.onsubmit()){
        return;
    }
	document.qtafi2.target='_self';
	document.qtafi2.__requestpage.value = parseInt(document.qtafi2.__page.value) + incr;
	document.qtafi2.submit();
}


/**
* Validator
*/
var valuelistener_Objects = new Array();
var submitlistener_Objects = new Array();

function attachValidator(){
	valuelistener_Objects.push(arguments[0]);
}

function attachSubmitListener(){
	submitlistener_Objects.push(arguments[0]);
}

function onFormSubmit(){
	for(var i = 0;  i < submitlistener_Objects.length; i++){
		submitlistener_Objects[i].formSubmit();
	}
	for(var i = 0;  i < valuelistener_Objects.length; i++){
		var re = valuelistener_Objects[i].checkInput();
		if(re == false) return false;
	}
	return true;
}

//-->