/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4;

import java.io.InputStream;
import java.util.List;


/**
 * 
 * 
 * @author maks
 *
 */
public interface ProjectConfiguration {
	
	void init();
	
	String getProjectName();
	
	boolean projectResourceExists(String file);
	
	List<String> listQuestionnaires();
	
	InputStream getProjectResource(String file);
	InputStream getConfigurationResource(String file);
	
	AuthenticationType getAuthentication();
	Runtime getRuntime();
	LogMode getLogMode();
}
