/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.auth;

import java.util.HashMap;

public class Authentication {

	private boolean authenticated = false;
	final private String id;
	private String credentials;
	private Object principal;
	private HashMap<String, String> properties = new HashMap<>();
	
	public Authentication(String id){
		this.id = id;
	}
	
	public static Authentication create(){
		return new Authentication(Long.toString(System.currentTimeMillis()));
	}
	
	public String getId() {
		return id;
	}
	
	public void putProperty(String key, String value){
		properties.put(key, value);
	}
	
	public String getProperty(String key){
		return properties.get(key);
	}
	
	public void setAuthenticated(boolean authenticated) {
		this.authenticated = authenticated;
	}
	
	public boolean isAuthenticated(){
		return authenticated;
	}
	
	public void setCredentials(String credentials) {
		this.credentials = credentials;
	}
	
	public String getCredentials() {
		return credentials;
	}
	
	public void setPrincipal(Object principal) {
		this.principal = principal;
	}
	
	public Object getPrincipal() {
		return principal;
	}
}
