/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.auth;

import de.tinu.qtafi4.QMLRequest;

public class AuthenticationToken {
	
	private final QMLRequest request;
	private final String projectname;
	
	public AuthenticationToken(QMLRequest request){
		this.request = request;
		this.projectname = request.getProjectConfiguration().getProjectName();

	}
	
	public QMLRequest getQMLRequest() {
		return request;
	}
	
	public String getProjectName(){
		return projectname;
	}
	
	public String getCredentials() {
		if(request.getHttpRequest().getParameter("__pin") != null){
			String pin = request.getHttpRequest().getParameter("__pin");
			return pin;
		}
		return null;
	}
}
