/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.data;

import java.util.HashMap;
import java.util.Map;

import de.tinu.qtafi4.QMLRequest;

public class AnonymUser implements User {
	
	private HashMap<String,Object> parameter = new HashMap<String, Object>();
	
	public AnonymUser(){
	}
	
	public String getId() {
		return "1";
	}
	
	@Override
	public int getRequestPage() {
		return 1;
	}
	
	public void write(QMLRequest request){
		for(String key : request.getHttpRequest().getParameterMap().keySet()){
			String[] array = request.getHttpRequest().getParameterMap().get(key);
			String v = array[0];
			//System.out.println("put " + key + " " + v);
			parameter.put(key, v);
		}
		//parameter.put("__requestpage", "1");
	}
	
	public Object getValue(String key){
		if(parameter.containsKey(key)) return parameter.get(key);
		return "-9";
	}
	
	public void setValue(String key, Object ob){
		parameter.put(key, ob);
	}
	
	public int getIntValue(String var) {
		if(parameter.containsKey(var)){
			try{
				return Integer.parseInt(parameter.get(var).toString());
			}
			finally { }
		}
		return -9;
	}

	public Map<String, Object> toMap() {
		return parameter;
	}
	
	@Override
	public String toString() {
		return "AnonymUser ";
	}
}
