/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import de.tinu.qtafi4.QMLRequest;
import de.tinu.qtafi4.data.User;

public class CVNode extends PostprocessorNode {

	public CVNode() {
		super("CV");
	}

	public void process(Element n, QMLRequest request, User user){
		String variable;
		document = n.getOwnerDocument();
		if(n.hasAttribute("variable")){
			variable = n.getAttribute("variable");
			String type = "radio";
			if(n.hasAttribute("type")) type = n.getAttribute("type");
			if(type.equals("radio")){
				Element replace = document.createElement("span");
				if(request.getColumnRegistry().getRegisterCount(variable)==0){
					Element hidden = document.createElement("input");
					hidden.setAttribute("type", "hidden");
					hidden.setAttribute("name", variable);
					request.getColumnRegistry().registerColumn(variable);
					hidden.setAttribute("value", user.getValue(variable).toString());
					replace.appendChild(hidden);
				}
				String value = "-9";
				if(n.hasAttribute("value")) value = n.getAttribute("value");
				Element radio = document.createElement("input");
				radio.setAttribute("id", variable + "-" + value);
				radio.setAttribute("type", "radio");
				radio.setAttribute("name", "__"+variable);
				radio.setAttribute("value", value);

				String ocl = "";
				if(n.hasAttribute("onClick")) ocl = n.getAttribute("onClick");

				radio.setAttribute("onClick","toggle_CV('"+variable+"','-9','"+value+"',"+(request.getColumnRegistry().getRegisterCount(variable)-1)+");" + ocl);
				if(n.hasAttribute("style")) radio.setAttribute("style", n.getAttribute("style"));
				if(n.hasAttribute("class")) radio.setAttribute("class", n.getAttribute("class"));
				//if(! n.hasAttribute("writeonly")){
					if(value.equals(user.getValue(variable))){
						radio.setAttribute("checked","checked");
					}
				//}
				replace.appendChild(radio);
				n.getParentNode().replaceChild(replace,n);
			}
			else if(type.equals("pulldown")){
				request.getColumnRegistry().registerColumn(variable);
				Element replace = document.createElement("select");
				replace.setAttribute("name", variable);
				String ocl = "";
				if(n.hasAttribute("onChange")) ocl = n.getAttribute("onChange");
				replace.setAttribute("onChange", "valueChanged('"+variable+"');" + ocl);
				String size = "1";
				if(n.hasAttribute("size")) size = n.getAttribute("size");
				replace.setAttribute("size", size);
				
				if(n.hasAttribute("style")) replace.setAttribute("style", n.getAttribute("style"));
				if(n.hasAttribute("class")) replace.setAttribute("class", n.getAttribute("class"));
				
				String value = user.getValue(variable).toString(); //here the variables will be added!
				//if(! n.hasAttribute("writeonly")) value = user.getValue(variable);

				NodeList chns = n.getChildNodes();
				for(int i = 0; i < chns.getLength(); i++){
					Node chn = chns.item(i);
					if(chn.getNodeType() == Node.ELEMENT_NODE){
						if(chn.getLocalName().equals("option")){
							Element opt = document.createElement("option");
							String v = ((Element)chn).getAttribute("value");
							opt.setAttribute("value", v);
							if(v.equals(value)) opt.setAttribute("selected","selected");
							opt.appendChild(document.createTextNode(((Element)chn).getAttribute("label")));
							replace.appendChild(opt);
						}
						else if(chn.getLocalName().equals("optgroup")){
							Element optgr = document.createElement("optgroup");
							optgr.setAttribute("label", ((Element)chn).getAttribute("label"));
							NodeList opts = chn.getChildNodes();
							for(int ii = 0; ii < opts.getLength(); ii++){
								Node optn = opts.item(ii);
								if(optn.getNodeType() == Node.ELEMENT_NODE && optn.getLocalName().equals("option")){
									Element opt = document.createElement("option");
									String v = ((Element)optn).getAttribute("value");
									opt.setAttribute("value", v);
									if(v.equals(value)) opt.setAttribute("selected", "selected");
									opt.appendChild(document.createTextNode(((Element)optn).getAttribute("label")));
									optgr.appendChild(opt);
								}
							}
							replace.appendChild(optgr);
						}
					}
				}
				n.getParentNode().replaceChild(replace,n);
			}
		}
	}
}