/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import de.tinu.qtafi4.QMLRequest;
import de.tinu.qtafi4.SurveyError;
import de.tinu.qtafi4.data.User;

/**
* <qtafi:ERROR >
* 	<message code="1">PIN invalid</message>
* </qtafi:ERROR>
*
*/
public class ERRORNode extends PostprocessorNode {

	public ERRORNode() {
		super("ERROR");
	}

	public void process(Element n, QMLRequest request, User user){
		document = n.getOwnerDocument();
		SurveyError err = request.getError();
		
		if(err == SurveyError.AUTHENTICATIONERROR){
			Element replace = document.createElement("span");
			String message = "ERROR";
			
			NodeList chns = n.getChildNodes();
			for(int i = 0; i < chns.getLength(); i++){
				Node chn = chns.item(i);
				if(chn.getNodeName().equalsIgnoreCase("message")){
					message = chn.getTextContent();
				}
			}
			
			Element htmlmess = document.createElement("span");
			htmlmess.appendChild(document.createTextNode(message));
			htmlmess.setAttribute("class", "errormessage");
			replace.appendChild(htmlmess);
			n.getParentNode().replaceChild(replace, n);
		}
		else {
			n.getParentNode().removeChild(n);
		}
	}
}