/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;

import org.w3c.dom.Element;

import de.tinu.qtafi4.QMLRequest;
import de.tinu.qtafi4.data.User;

public class HIDDENNode extends PostprocessorNode {

	public HIDDENNode() {
		super("HIDDEN");
	}

	public void process(Element n, QMLRequest request, User user){
		String variable;
		document = n.getOwnerDocument();
		if(n.hasAttribute("variable")){
			variable = n.getAttribute("variable");
			Element replace = document.createElement("input");
			replace.setAttribute("type", "hidden");
			replace.setAttribute("name", variable);
			if(n.hasAttribute("staticvalue")){
				request.getColumnRegistry().registerColumn(variable);
				user.getValue(variable);
				replace.setAttribute("value", n.getAttribute("staticvalue"));
			}
			else {
				request.getColumnRegistry().registerColumn(variable);
				replace.setAttribute("value", user.getValue(variable).toString());
			}
			n.getParentNode().replaceChild(replace, n);
		}
	}
}