/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;


import java.net.URLEncoder;
import java.util.Vector;

import org.w3c.dom.Element;

import de.tinu.qtafi4.QMLRequest;
import de.tinu.qtafi4.data.User;

/**
* <qtafi:LINK to="http://" text="Link text" type="button" {data=""|encryptdata="__pin=$__pin&source_project=$__project"}  />
*
*/
public class LINKNode extends PostprocessorNode {
	
	public LINKNode() {
		super("LINK");
	}

	public void process(Element n, QMLRequest request, User data){
		document = n.getOwnerDocument();
		Element replace = document.createElement("input");
		
		if(n.hasAttribute("style")){
			replace.setAttribute("style", n.getAttribute("style"));
		}
		if(n.hasAttribute("text")){
			replace.setAttribute("value", n.getAttribute("text"));
		}
		String to = "";
		if(n.hasAttribute("to")) to = n.getAttribute("to");
//		if(user.getRequestConfiguration() == null){
//			replace.setAttribute("type", "button");
//			n.getParentNode().replaceChild(replace, n);
//			return;
//		}
		
		Vector<String> datas = new Vector<String>();
		if(n.hasAttribute("encryptdata")){ 
			String a = n.getAttribute("encryptdata");
			String[] aa = a.split("\\|");
			for(String k : aa){
				String key = k.substring(0, k.indexOf("="));
				String val = k.substring(k.indexOf("=")+1, k.length());
				if(val.equals("$__project")) datas.add(key+"="+request.getProjectConfiguration().getProjectName());
				else if(val.equals("$__pin")) datas.add(key+"="+data.getValue("__pin"));
				else if(val.equals("$__id")) datas.add(key+"="+data.getId());
				else datas.add(key+"="+data.getValue(key));
			}
			String adata = "";
			for(int i = 0; i < datas.size(); i++){
				adata += datas.get(i);
				if(i < (datas.size()-1)) adata += "&";
			}
			//System.out.println("data " + data);
			//TODO encrypt
			String crypt = adata;
			String encoded = "";
			try{
				encoded = URLEncoder.encode(crypt, "UTF-8");
			}
			catch (Exception e) {
				e.printStackTrace();
			}
			replace.setAttribute("type", "button");
			replace.setAttribute("onclick", "document.location.href='"+to+"?~"+encoded+"';");
			n.getParentNode().replaceChild(replace, n);
		}
		else if(n.hasAttribute("data")){
			String a = n.getAttribute("data");
			String[] aa = a.split("\\|");
			for(String k : aa){
				String key = k.substring(0, k.indexOf("="));
				String val = k.substring(k.indexOf("=")+1, k.length());
				if(val.equals("$__project")) datas.add(key+"="+request.getProjectConfiguration().getProjectName());
				else if(val.equals("$__pin")) datas.add(key+"="+data.getValue("__pin"));
				else if(val.equals("$__id")) datas.add(key+"="+data.getId());
				else datas.add(key+"="+data.getValue(key));
			}
			String adata = "";
			for(int i = 0; i < datas.size(); i++){
				adata += datas.get(i);
				if(i < (datas.size()-1)) adata += "&";
			}
			
			System.out.println("data " + data);
			replace.setAttribute("type", "button");
			replace.setAttribute("onclick", "document.location.href='"+to+"?"+data+"';");
			n.getParentNode().replaceChild(replace, n);
		}
	}
}
