/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;

import org.w3c.dom.Element;

import de.tinu.qtafi4.QMLRequest;
import de.tinu.qtafi4.data.User;

public class MDNode extends PostprocessorNode {

	public MDNode() {
		super("MD");
	}

	public void process(Element n, QMLRequest request, User user){
		String variable;
		document = n.getOwnerDocument();
		if(n.hasAttribute("variable")){
			variable = n.getAttribute("variable");
			Element replace = document.createElement("span");

			Element hidden = document.createElement("input");
			
			hidden.setAttribute("type", "hidden");
			hidden.setAttribute("name", variable);
			request.getColumnRegistry().registerColumn(variable);
			hidden.setAttribute("value", user.getValue(variable).toString());
			replace.appendChild(hidden);

			Element chck = document.createElement("input");
			chck.setAttribute("id", variable + "-1");
			chck.setAttribute("type", "checkbox");
			chck.setAttribute("name", "__"+variable);
			chck.setAttribute("value", "1");
			
			if(n.hasAttribute("style")) chck.setAttribute("style", n.getAttribute("style"));
			if(n.hasAttribute("class")) chck.setAttribute("class", n.getAttribute("class"));

			String ocl = "";
			if(n.hasAttribute("onClick")) ocl = n.getAttribute("onClick");
			chck.setAttribute("onClick","toggle_MD('"+variable+"','-9','1');"+ocl);

			if("1".equals(user.getValue(variable))){
				chck.setAttribute("checked","checked");
			}

			replace.appendChild(chck);
			n.getParentNode().replaceChild(replace,n);
		}
	}
}