/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;

import org.w3c.dom.Element;

import de.tinu.qtafi4.QMLRequest;
import de.tinu.qtafi4.data.User;

public class MENode extends PostprocessorNode {

	public MENode() {
		super("ME");
	}

	public void process(Element n, QMLRequest request, User data){
		String variable;
		document = n.getOwnerDocument();
		if(n.hasAttribute("variable")){
			variable = n.getAttribute("variable");
			Element replace = document.createElement("input");
			replace.setAttribute("id", variable + "-ME");
			replace.setAttribute("type", "text");
			replace.setAttribute("name", variable);

			replace.setAttribute("style", "text-align:right");

			String size = "10";
			if(n.hasAttribute("size")) size = n.getAttribute("size");
			replace.setAttribute("size", size);
 			replace.setAttribute("maxlength", size);
 			
 			request.getColumnRegistry().registerColumn(variable);
			String value = data.getValue(variable).toString();
			if(value.equals("-9")) value = "";
			replace.setAttribute("value",value);
			
			if(n.hasAttribute("style")) replace.setAttribute("style", n.getAttribute("style"));
			if(n.hasAttribute("class")) replace.setAttribute("class", n.getAttribute("class"));

			replace.setAttribute("onkeyup", "valueChanged('"+variable+"');");
			replace.setAttribute("onkeyPress", "return checkInteger(event,'44');");
			
			PostprocessorNodeUtils.handleFilter(document, n);
			n.getParentNode().replaceChild(replace, n);
		}
	}
}