/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;

import org.w3c.dom.Element;

import de.tinu.qtafi4.QMLRequest;
import de.tinu.qtafi4.data.User;

public class ORNode extends PostprocessorNode {

	public ORNode() {
		super("OR");
	}

	public void process(Element n, QMLRequest request, User data){
		String variable;
		document = n.getOwnerDocument();
		if(n.hasAttribute("variable")){
			variable = n.getAttribute("variable");
			Element replace = document.createElement("span");
			if(request.getColumnRegistry().getRegisterCount(variable)==0){
				Element hidden = document.createElement("input");
				hidden.setAttribute("type", "hidden");
				hidden.setAttribute("name", variable);
				request.getColumnRegistry().registerColumn(variable);
				hidden.setAttribute("value", data.getValue(variable).toString());
				replace.appendChild(hidden);
			}
			String value = "1";
			if(n.hasAttribute("value")) value = n.getAttribute("value");
			Element radio = document.createElement("input");
			radio.setAttribute("id", variable + "-" + value);
			radio.setAttribute("type", "radio");
			radio.setAttribute("name", "__"+variable);
			radio.setAttribute("value", value);
			radio.setAttribute("onClick","toggle_OR('"+variable+"','-9','"+value+"',"+(request.getColumnRegistry().getRegisterCount(variable)-1)+");");
			
			if(n.hasAttribute("style")) radio.setAttribute("style", n.getAttribute("style"));
			if(n.hasAttribute("class")) radio.setAttribute("class", n.getAttribute("class"));

			if(value.equals(data.getValue(variable).toString())){
				radio.setAttribute("checked", "checked");
			}
			replace.appendChild(radio);
			n.getParentNode().replaceChild(replace,n);
		}
	}
}