/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class PostprocessorNodeUtils {
	
	public static void handleFilter(Document doc, Element n){
		String variable = n.getAttribute("variable");
		NodeList nl = n.getElementsByTagName("filter");
		if(nl == null) return;
		if(nl.getLength() == 0) return;
		Element filter = (Element) nl.item(0);
		NodeList enl = n.getElementsByTagName("enable_if");
		if(enl == null) return;
		if(enl.getLength() == 0) return;
		StringBuffer scr = new StringBuffer();
		Element sc = doc.createElement("script");
		for(int i = 0; i < enl.getLength(); i++){
			Element enable = (Element) enl.item(i);
			if(! enable.hasAttribute("variable") || ! enable.hasAttribute("value")) return;
			String var = enable.getAttribute("variable");
			String val = enable.getAttribute("value");
			
			String op = "IS";
			if(enable.hasAttribute("operator")) op = enable.getAttribute("operator");
			String uid = Integer.toString((int)(Math.random()*1000000.));
			scr.append("VariableListenerObject"+uid+" = function(){ }\n");
			scr.append("VariableListenerObject"+uid+".prototype.notifyVariableChanged = function(){\n");
			if(op.equals("IS_NOT")){
				scr.append("if(not_equals(document.qtafi2['"+var+"'].value,'"+val+"')){\n");
				scr.append("enableVariable('"+variable+"');\n");
				scr.append("} else {\n");
				scr.append("disableVariable('"+variable+"');\n");
				scr.append("}\n");
			}
			else if(op.equals("IS")){
				scr.append("if(equals(document.qtafi2['"+var+"'].value,'"+val+"')){\n");
				scr.append("enableVariable('"+variable+"');\n");
				scr.append("} else {\n");
				scr.append("disableVariable('"+variable+"');\n");
				scr.append("}\n");
			}
			scr.append("}\n");
			scr.append("var listenerobj"+uid+" = new VariableListenerObject"+uid+"();\n");
			scr.append("attachVariableListener('"+var+"',listenerobj"+uid+");\n");
		}
		sc.setTextContent(scr.toString());
		n.getParentNode().appendChild(sc);
	}
}
