/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;

import org.w3c.dom.Element;

import de.tinu.qtafi4.QMLRequest;
import de.tinu.qtafi4.data.User;

/**
*
* <qtafi:RECEPTION variable="var" method="post" requestvar="var" />
*
* fetches the variable <var> from the url and writes it to the database
*/
public class RECEPTIONNode extends PostprocessorNode {

	public RECEPTIONNode() {
		super("RECEPTION");
	}

	public void process(Element n, QMLRequest request, User data){
		String variable;
		document = n.getOwnerDocument();
		if(n.hasAttribute("variable")){
			variable = n.getAttribute("variable");
			String requestvar = variable;
			if(n.hasAttribute("requestvar")){
				requestvar = n.getAttribute("requestvar");
			}

			request.getColumnRegistry().registerColumn(variable);
		
			String value = data.getValue(requestvar).toString();
			System.out.println("RECEPTION  "+ requestvar + " = " + value );

			Element input = document.createElement("input");
			input.setAttribute("type", "hidden");
			input.setAttribute("name", variable);
			input.setAttribute("value", value);

			n.getParentNode().replaceChild(input, n);
		}
	}
}