/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import org.w3c.dom.Element;

import de.tinu.qtafi4.QMLRequest;
import de.tinu.qtafi4.data.User;
import de.tinu.qtafi4.qml.CodeInterpreter;

/**
 * <qtafi:SNIPPET href="code.java" />
 * 
 * <qtafi:SNIPPET>
 * 	do something
 *  return "Hallo Welt";
 * </qtafi:SNIPPET>
 * 
 * <qtafi:SNIPPET type="xml">
 *  Element ex = document.createElement("x");
 * 	return ex;
 * </qtafi:SNIPPET>
 * 
 */
public class SNIPPETNode extends PostprocessorNode {
	
	public SNIPPETNode() {
		super("SNIPPET");
	}

	public void process(Element n, QMLRequest request, User data){
		document = n.getOwnerDocument();
		Element replace = document.createElement("span");
		if(n.hasAttribute("href")){
			String url = n.getAttribute("href");
			String file = url;
			
			StringBuffer output = new StringBuffer();
			try {
				BufferedReader reader;
				reader = new BufferedReader(new FileReader(file));
				StringBuffer script = new StringBuffer();
				String l = null;
				while((l=reader.readLine()) != null) script.append(l+"\n");
				CodeInterpreter interpreter = new CodeInterpreter();
			
				interpreter.setParams(data.toMap());
				interpreter.setParam("user", data);
				
				interpreter.setParam("document", replace.getOwnerDocument());
				interpreter.interpret(script.toString(), output);
			} 
			catch (FileNotFoundException e) {
				e.printStackTrace();
			} 
			catch (IOException e) {
				e.printStackTrace();
			}
			replace.setTextContent(output.toString());
			n.getParentNode().replaceChild(replace, n);
			return;
		}
		else if(n.hasAttribute("type")){
			if(n.getAttribute("type").equalsIgnoreCase("XML")){
				CodeInterpreter interpreter = new CodeInterpreter();
				interpreter.setParams(data.toMap());
				interpreter.setParam("user", data);
				interpreter.setParam("document", replace.getOwnerDocument());
				interpreter.interpret(n.getTextContent(), replace);
				n.getParentNode().replaceChild(replace, n);
				return;
			}
		}
		if(n.getTextContent().length() > 10){
			StringBuffer output = new StringBuffer();
			CodeInterpreter interpreter = new CodeInterpreter();
			interpreter.setParams(data.toMap());
			interpreter.setParam("user", data);
			interpreter.setParam("document", replace.getOwnerDocument());
			interpreter.interpret(n.getTextContent(), output);
			if(output != null) replace.setTextContent(output.toString());
			n.getParentNode().replaceChild(replace, n);
		}
	}
}
