/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;

import org.w3c.dom.Element;

import de.tinu.qtafi4.QMLRequest;
import de.tinu.qtafi4.data.User;

/**
* 
* <qtafi:TE variable="var1" size="40" writeonly="true" />
* 
* Filter:
* <qtafi:TE variable="var1">
* 	<filter>
* 		<enable_if variable="vx" value="y" />
*	</filter>
* </qtafi:TE>
* 
*/
public class TENode extends PostprocessorNode {
	
	public TENode() {
		super("TE");
	}

	public static final int DEFAULT_SIZE = 40;

	public void process(Element n, QMLRequest request, User data){
		String variable;
		document = n.getOwnerDocument();
		if(n.hasAttribute("variable")){
			variable = n.getAttribute("variable");
			Element replace = document.createElement("input");
			replace.setAttribute("id", variable + "-TE");
			replace.setAttribute("type", "text");
			replace.setAttribute("name", variable);
			String size = Integer.toString(DEFAULT_SIZE);
			if(n.hasAttribute("size")) size = n.getAttribute("size");
			replace.setAttribute("size", size);
			String value = data.getValue(variable).toString();
			if(n.hasAttribute("writeonly")) value = "-9";
			if(n.hasAttribute("style")) replace.setAttribute("style", n.getAttribute("style"));
			if(n.hasAttribute("class")) replace.setAttribute("class", n.getAttribute("class"));
			if(value.equals("-9")) value = "";
			replace.setAttribute("value", value);

			replace.setAttribute("onkeyup", "valueChanged('"+variable+"');");
			replace.setAttribute("onkeyPress", "return;");
			request.getColumnRegistry().registerColumn(variable);
			PostprocessorNodeUtils.handleFilter(document, n);
			n.getParentNode().replaceChild(replace, n);
		}
	}
}