/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;

import org.w3c.dom.Element;

import de.tinu.qtafi4.QMLRequest;
import de.tinu.qtafi4.data.User;

public class TLNode extends PostprocessorNode {

	public TLNode() {
		super("TL");
	}

	public void process(Element n, QMLRequest request, User user){
		String variable;
		document = n.getOwnerDocument();
		if(n.hasAttribute("variable")){
			variable = n.getAttribute("variable");
			request.getColumnRegistry().registerColumn(variable);
			
			Element replace = document.createElement("textarea");
			replace.setAttribute("name", variable);
			String width = "60";
			if(n.hasAttribute("width")) width = n.getAttribute("width");
			replace.setAttribute("cols", width);

			String height = "5";
			if(n.hasAttribute("height")) height = n.getAttribute("height");
			replace.setAttribute("rows", height);
			
			String value = user.getValue(variable).toString();
			if(n.hasAttribute("writeonly")) value = "-9";
			
			if(n.hasAttribute("style")) replace.setAttribute("style", n.getAttribute("style"));
			if(n.hasAttribute("class")) replace.setAttribute("class", n.getAttribute("class"));
			
			if(value.equals("-9")) value = " ";

			replace.appendChild(document.createTextNode(value));
			n.getParentNode().replaceChild(replace, n);
		}
	}
}