/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import de.tinu.qtafi4.QMLRequest;
import de.tinu.qtafi4.data.User;
import de.tinu.qtafi4.qml.CodebookFilter;

/**
* <qtafi:USE_IF variable="" value="" operator="">
*	<sdfsf />
* </qtafi:USE_IF>
*/
public class USE_IFNode extends PostprocessorNode {

	public USE_IFNode() {
		super("USE_IF");
	}

	public void process(Element n, QMLRequest request, User data){
		document = n.getOwnerDocument();
		if(n.hasAttribute("variable")){
			Element replace = document.createElement("span");
			boolean b = CodebookFilter.eval(n, data);
			if(b){
				NodeList chns = n.getChildNodes();
				for(int i = 0; i < chns.getLength(); i++){
					Node chn = chns.item(i);
					Node nn = chn.cloneNode(true);
					replace.appendChild(nn);
				}
				//TODO
				postprocessor.processSubTree(replace, request, data);
				n.getParentNode().replaceChild(replace,n);
			}
			else n.getParentNode().removeChild(n);
		}
	}
}