/*******************************************************************************
 * Questionnaire runtime
 *
 * Copyright (C) 2015 martin.guist@eoda.de
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.postprocessor;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import de.tinu.qtafi4.QMLRequest;
import de.tinu.qtafi4.data.User;

public class VARNode extends PostprocessorNode {

	public VARNode() {
		super("VAR");
	}

	public void process(Element n, QMLRequest request, User user){
		String variable;
		document = n.getOwnerDocument();
		if(n.hasAttribute("variable")){
			variable = n.getAttribute("variable");
			boolean skipmissing = false;
			if(n.hasAttribute("skipmissing")){
				if(n.getAttribute("skipmissing").equalsIgnoreCase("true")){
					skipmissing = true;
				}
			}
			boolean usevaluemap = false;
			if(n.hasAttribute("usevaluemap")){
				if(n.getAttribute("usevaluemap").equalsIgnoreCase("true")){
					usevaluemap = true;
				}
			}
			
			
			Element replace = document.createElement("span");
			//do not register variable!
			//user.registerVariable(variable);
			String val = user.getValue(variable).toString();
			if(usevaluemap){
				NodeList nl = n.getChildNodes();
				if(nl != null){
					for(int i = 0; i < nl.getLength(); i++){
						Node nn = nl.item(i);
						if(nn.getNodeName().equals("value") && nn.getNodeType() == Node.ELEMENT_NODE){
							Element ne = (Element) nn;
							if(ne.hasAttribute("key")){
								if(ne.getAttribute("key").equals(val)){
									val = ne.getTextContent();
								}
							}
						}
					}
				}
			}
			else if(skipmissing){
				if(val.equals("-9")) val = "";
			}
			
			replace.appendChild(document.createTextNode(val));
			n.getParentNode().replaceChild(replace, n);
		}
	}
}