/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.db;


import java.io.InputStream;
import java.util.List;

import de.tinu.qtafi4.model.PathInfo;
import de.tinu.qtafi4.model.Question;
import de.tinu.qtafi4.model.QuestionnaireOptions;
import de.tinu.qtafi4.model.Variable;
import de.tinu.qtafi4.tree.TreeNode;



public interface QuestionDB {

	void init(String project, String qmlfile);
	
	TreeNode questionnaireInfo();
	TreeNode questionnaireInfo(NodeFilter nodefilter);
	TreeNode getTreeNode(TreeNode root, String uid);
	
	QuestionnaireOptions getOptions();
	void setOptions(QuestionnaireOptions opt);
	
	Question get(PathInfo info);
	boolean update(Question question);
	boolean delete(Question question);
	
	Question append(PathInfo pos, String type);
	//Question append(PathInfo pos);
	Question prepend(PathInfo pos, String type);
	Question insertBefore(PathInfo pos, String type);
	Question insertBehind(PathInfo pos, String type);
	
	boolean moveBehind(PathInfo pos, Question quest);
	boolean moveBefore(PathInfo pos, Question quest);
	boolean moveInsideAsFirst(PathInfo pos, Question quest);
	boolean moveInsideAsLast(PathInfo pos, Question quest);
	
	Question appendPage();
	boolean deletePage(int page);
	
	boolean movePageBehind(PathInfo pos, PathInfo page);
	boolean movePageBefore(PathInfo pos, PathInfo page);
	
	List<Variable> getAllVariables();
	
	
	void transform(StringBuffer result, String path, InputStream xsltfile, String... params);
}

