/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.model;

import java.util.ArrayList;
import java.util.List;

public class Filter {

	//public static final int TYPE_GROUP = 0;
	public static final int TYPE_GROUP_OR = 1;
	public static final int TYPE_GROUP_AND = 2;
	public static final int TYPE_FILTER = 99;
	
	public int type = TYPE_FILTER;
	public String variable;
	public String value;
	public String operator = "IS";
	public String ref = null;
	public String label = null;
	
	public List<Filter> children = new ArrayList<Filter>();
	
	public Filter() {
	}
	
	public Filter(int type) {
		this.type = type;	
	}
	
	public Filter(String variable, String value) {
		this.variable = variable;
		this.value = value;
	}
	
	public Filter(String variable, String value, String operator) {
		this.variable = variable;
		this.value = value;
		this.operator = operator;
	}
	
	public void add(Filter child){
		children.add(child);
	}
	
	public String toString(){
		StringBuffer buf = new StringBuffer();
		if(type == TYPE_GROUP_AND){
			buf.append("AND-group: [\n");
			for(Filter f: children){
				buf.append(f.toString());
			}
			buf.append("]\n");
		}
		else if(type == TYPE_GROUP_OR){
			buf.append("OR-group: [\n");
			for(Filter f: children){
				buf.append(f.toString());
			}
			buf.append("]\n");
		}
		else {
			buf.append("variable:\t " + variable + "\n");
			buf.append("value:\t" + value + "\n");
			buf.append("ref:\t" + ref + "\n");
		}
		return buf.toString();
	}
}
