/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.tree;


public class QuestionnaireNode extends TreeNode {
	
	
	public QuestionnaireNode() {
		super("root");
		this.type = "codebook";
	}
	
	public void addPage(PageNode page){
		page.parent = this;
		children.add(page);
	}
	
	public int getPageCount(){
		int p = 0;
		for(TreeNode n : children){
			if(n.type.equals("Page")) p++;
		}
		return p;
	}
	
	public String toString(){
		StringBuffer buf = new StringBuffer();
		buf.append("Questionnaire \n");
		for(TreeNode p : children){
			buf.append(p + "\n");
		}
		return buf.toString();
	}
}
