/*******************************************************************************
 * Quest survey management 
 *
 * Copyright (C) 2015 eoda
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package de.tinu.qtafi4.tree;

import java.util.ArrayList;
import java.util.List;

public abstract class TreeNode {

	public final String uid;
	public String id;
	//public String path;
	public String label;
	public String type;
	public TreeNode parent;
	
	public List<TreeNode> children = new ArrayList<TreeNode>();
	
	public TreeNode(String uid){
		this.uid = uid;
	}
	
	public String getLabel(){
		return label;
	}
	
	public void addNode(TreeNode node){
		node.parent = this;
		this.children.add(node);
	}
	
	public final List<TreeNode> getChildren(){
		return children;
	}
	
	public String toString(){
		return label;
	}
}
